<?php
/***************************************************** 
 *                System biblioteczny                * 
 ***************************************************** 
 * Wersja: 1.01 Stable                               * 
 * Data: 24.01.2009 (11:06)                          * 
 * Autor: Jacek Kowalski (http://jacekk.info)        * 
 *                                                   * 
 * Utwor rozprowadzany na licencji                   * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/ * 
 *****************************************************/

class ksiazki {
	static $LT_API = '';
	
	static $cache = array();
	
	static function okladka($ISBN) {
		if(!function_exists('curl_init')) {
			return FALSE;
		}
		
		if(strlen($ISBN)==13) {
			if(substr($ISBN, 0, 3)=='978') {
				$ISBN10 = convert::ISBN13_to_ISBN10($ISBN);
			}
			else
			{
				$ISBN10 = $ISBN;
			}
		}
		else
		{
			return FALSE;
		}
		
		if(!file_exists('./covers/'.$ISBN) || (filesize('./covers/'.$ISBN)==0 AND filemtime('./covers/'.$ISBN)+2592000 < time())) {
			
			$get = 'http://www.librarything.com/devkey/'.self::$LT_API.'/small/isbn/'.$ISBN10;
			$curl = curl_init($get);
			curl_setopt($curl, CURLOPT_FOLLOWLOCATION, TRUE);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
			
			$img = @curl_exec($curl);
			$code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
			$type = curl_getinfo($curl, CURLINFO_CONTENT_TYPE);
			if($code != 200 || substr($type, 0, 6) != 'image/' || $img == FALSE || strlen($img) < 100) {
				touch('./covers/'.$ISBN);
				return FALSE;
			}
			else
			{
				file_put_contents('./covers/'.$ISBN, $img);
				return TRUE;
			}
		}
		elseif(file_exists('./covers/'.$ISBN) AND filesize('./covers/'.$ISBN)>100) {
			return TRUE;
		}
	}
	
	static function okladka_big($ISBN) {
		if(!function_exists('curl_init')) {
			return FALSE;
		}
		
		if(strlen($ISBN)==13) {
			if(substr($ISBN, 0, 3)=='978') {
				$ISBN10 = convert::ISBN13_to_ISBN10($ISBN);
			}
			else
			{
				$ISBN10 = $ISBN;
			}
		}
		else
		{
			return FALSE;
		}
		
		if(file_exists('./covers/'.$ISBN) && !file_exists('./covers_big/'.$ISBN) || (file_exists('./covers_big/'.$ISBN) AND filesize('./covers_big/'.$ISBN)==0 AND filemtime('./covers_big/'.$ISBN)+2592000 < time())) {
			$get = 'http://www.librarything.com/devkey/'.self::$LT_API.'/large/isbn/'.$ISBN10;
			$curl = curl_init($get);
			curl_setopt($curl, CURLOPT_FOLLOWLOCATION, TRUE);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
			
			$img = curl_exec($curl);
			$code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
			$type = curl_getinfo($curl, CURLINFO_CONTENT_TYPE);
			if($code != 200 || substr($type, 0, 6) != 'image/' || $img == FALSE || strlen($img) < 100) {
				touch('./covers_big/'.$ISBN);
				return FALSE;
			}
			else
			{
				file_put_contents('./covers_big/'.$ISBN, $img);
				return TRUE;
			}
		}
		elseif(file_exists('./covers_big/'.$ISBN) AND filesize('./covers_big/'.$ISBN)>100) {
			return TRUE;
		}
	}
	
	static function dodaj(&$dane) {
		validate::KOD($dane['id'], FALSE);
		
		if($dane['ISBN']) {
			$t = validate::type($dane['ISBN']);
			if($t!='ISBN') {
				error::add('W polu ISBN znajduje się '.$t);
			}
		}
		if($dane['ISSN']) {
			$t = validate::type($dane['ISSN']);
			if($t!='ISSN') {
				error::add('W polu ISSN znajduje się '.$t);
			}
		}
		
		if($dane['jezyk']=='pol') {
			$dane['jezyk'] = 'polski';
		}
		
		db2::add('ksiazki', $dane);
		self::cache_update($dane['id']);
	}
	
	static function exists($kod) {
		$info = self::cache_get($kod);
		if(isset($info['id'])) {
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	
	static function cache_get($kod) {
		$kod = (int)$kod;
		
		if(!isset(self::$cache[(int)$kod])) {
			self::cache_update($kod);
		}
		
		return self::$cache[(int)$kod];
	}
	
	static function cache_add($kod, &$dane) {
		if($dane['od2']) {
			$dane['od'] = $dane['od2'];
			unset($dane['od2']);
		}
		self::$cache[(int)$kod] = $dane;
	}
	
	static function cache_addarray(&$dane) {
		foreach($dane as &$r) {
			self::cache_add($r['id'], $r);
		}
	}
	
	static function cache_clear($id=NULL) {
		if(is_null($id)) {
			self::$cache = array();
		}
		else
		{
			unset(self::$cache[(int)$id]);
		}
	}
	
	static function edytuj(&$dane) {
		validate::KOD($dane['id']);
		$kod = $dane['id'];
		
		if($dane['id']=='' OR empty($dane['autor']) OR empty($dane['tytul']) OR empty($dane['jezyk'])) {
			error::add('Brak wymaganych danych o książce (kod, autor, tytuł, język)');
		}
		
		if($dane['nid']!='') {
			validate::KOD($dane['nid']);
			$dane['id'] = $dane['nid'];
		}
		
		unset($dane['nid']);
		
		if($dane['ISBN']) {
			$t = validate::type($dane['ISBN']);
			if($t!='ISBN') {
				error::add('W polu ISBN znajduje się '.$t);
			}
		}
		if($dane['ISSN']) {
			$t = validate::type($dane['ISSN']);
			if($t!='ISSN') {
				error::add('W polu ISSN znajduje się '.$t);
			}
		}
		
		if(!$dane['wycofana']) {
			$dane['wycofana'] = 0;
			$dane['powod'] = NULL;
		}
		
		db2::edit('ksiazki', $dane, array('id' => $kod));
		self::cache_update($kod);
		if($dane['id']!=$kod) {
			self::cache_update($dane['id']);
		}
	}
	
	static function miejsce($regal, $polka, $rzad, $where) {
		db2::edit('ksiazki', array('regal' => strtoupper($regal), 'polka' => $polka, 'rzad' => $rzad), $where);
		self::cache_clear();
	}
	
	static function usun(&$kod) {
		validate::KOD($kod);
		
		db2::del('ksiazki', array('id' => $kod));
		self::cache_clear($kod);
	}
	
	static function cache_update($kod) {
		self::cache_add($kod, sql::fetchone(sql::query('SELECT *, (SELECT MAX(`od`) FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id`) as `od2`, (SELECT `do` FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id` AND `od`=`od2`) as `do`, (SELECT `kto` FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id` AND `od`=`od2`) as `kto` FROM `ksiazki` WHERE `id`=\''.sql::escape($kod).'\'')));
	}
	
	static function szukaj_KOD($kod) {
		validate::KOD($kod, TRUE);
		
		return self::cache_get($kod);
	}
	
	static function szukaj_ISBN($ISBN) {
		validate::EAN($ISBN);
		
		return db2::get('ksiazki', '*', array('ISBN' => $ISBN), NULL, 10);
	}
	
	static function szukaj_ISSN($ISSN) {
		validate::EAN($ISSN);
		
		return db2::get('ksiazki', '*', array('ISSN' => $ISSN), NULL, 10);
	}
	
	static function szukaj_info($dane, $order=NULL, $start=NULL, $limit=30) {
		$allow = array('id', 'tytul', 'autor', 'wydawnictwo', 'miejsce', 'rok', 'wydanie', 'wycofana');
		$replace = array('tytul' => 'tytul~~', 'autor' => 'autor~~', 'wydawnictwo' => 'wydawnictwo~~');
		
		$where = array();
		
		foreach($dane as $key => $value) {
			if(!in_array($key, $allow) OR $value==='') {
				continue;
			}
			
			if($replace[$key]) {
				$key = $replace[$key];
			}
			
			$where[$key] = $value;
		}
		
		if($where['id']) {
			validate::$kod = TRUE;
			switch(validate::type($where['id'])) {
				case 'ISBN':
					$where['ISBN'] = $where['id'];
					unset($where['id']);
				break;
				case 'ISSN':
					$where['ISBN'] = $where['id'];
					unset($where['id']);
				break;
				case 'MSC':
					$where['regal'] = $where['id'];
					if($where['polka']) {
						$where['polka'] = $dane['polka'];
					}
					if($where['rzad']) {
						$where['rzad'] = $dane['rzad'];
					}
					unset($where['id']);
				break;
			}
			validate::$kod = FALSE;
		}
		
		if(!$where['regal']) {
			unset($where['polka']);
			unset($where['rzad']);
		}
		
		if($where['id']) {
			$ret[] = self::szukaj_KOD($where['id']);
			$num = count($ret);
		}
		else
		{
			if($dane['do']) {
				$num = db2::num('pozycz', 'id', array('do' => NULL));
				if($num==0) {
					$ret = array();
				}
				else
				{
					$ret = db2::get(array('ksiazki', array('L', 'pozycz', 'USING', 'id')), '*', array('od!' => NULL, 'do' => NULL), $order, $start, $limit);
				}
			}
			else
			{
				$num = db2::num('ksiazki', 'id', $where);
				if($num==0) {
					$ret = array();
				}
				else
				{
					$ret = sql::fetch(sql::query('SELECT *, (SELECT MAX(`od`) FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id`) as `od2`, (SELECT `do` FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id` AND `od`=`od2`) as `do`, (SELECT `kto` FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id` AND `od`=`od2`) as `kto`  FROM `ksiazki`'.db2::__combine_where($where).db2::__combine_order($order).db2::__combine_limit($start, $limit)));
				}
			}
			
			self::cache_addarray($ret);
		}
		
		return array($num, $ret, db2::revelance());
	}
}
?>
